﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Input;

namespace PivotGridUsingFlatPivotTable.ViewModel
{
	public class DelegateCommand : ICommand
	{
		private readonly Action executeAction;

		public DelegateCommand(Action executeAction)
		{
			this.executeAction = executeAction;
		}

		public void Execute(object parameter)
		{
			if (executeAction != null)
			{
				executeAction();
			}
		}

		public bool CanExecute(object parameter)
		{
			return true;
		}

		public event EventHandler CanExecuteChanged;
	}
}
