﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows.Input;
using PivotGridUsingFlatPivotTable.DataSource;

namespace PivotGridUsingFlatPivotTable.ViewModel
{
	public class TestViewModel : INotifyPropertyChanged
	{
		public event PropertyChangedEventHandler PropertyChanged;

		private readonly ICommand loadTestDataCommand;
		private readonly IFlatPivotServerDataSource serverDataSource;
		private readonly FlatPivotDataSource flatPivotDataSource;

		public TestViewModel()
		{
			loadTestDataCommand = new DelegateCommand(LoadTestData);

			// This will produce the mock flat pivot table with test data
			serverDataSource = new MockFlatPivotServerDataSource();

			// I will attempt to bind the pivot-grid to this
			flatPivotDataSource = new FlatPivotDataSource(serverDataSource);
		}

		private void LoadTestData()
		{
			// Presumably I have to prime the rows and columns so that the actual server 
			// request internally will know what it needs to know with regards to 
			// axes, groupings and measures.

			// Is this the right way to do it? - it doesn't seem do anything at the moment...
			flatPivotDataSource.RefreshGrid();

			// So...in the meantime, I'll just hack in a refresh attempt
			flatPivotDataSource.RefreshDataHackStyle();
		}

		public FlatPivotDataSource FlatPivotDataSource
		{
			get { return flatPivotDataSource; }
		}

		public ICommand LoadTestDataCommand
		{
			get { return loadTestDataCommand; }
		}
	}
}
